@echo off
@echo --------- Choose Visual C++ version ----------
goto SET_VC_VER

:BUILD
@echo --------- Compile source code ----------
ml64 -c amd64_asm_test.asm
cl -c test.c
link test.obj amd64_asm_test.obj
del *.obj

goto END

:VC8
@echo set environment for VC++ 2005 (VC8.0)
if exist "C:\Program Files\Microsoft Visual Studio 8\VC\vcvarsall.bat" call "C:\Program Files\Microsoft Visual Studio 8\VC\vcvarsall.bat" x86_amd64
if exist "C:\Program Files (x86)\Microsoft Visual Studio 8\VC\vcvarsall.bat" call "C:\Program Files (x86)\Microsoft Visual Studio 8\VC\vcvarsall.bat" x64
goto BUILD

:VC9
@echo set environment for VC++ 2008 (VC9.0)
if exist "C:\Program Files\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" call "C:\Program Files\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x86_amd64
if exist "C:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" call "C:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x64

goto BUILD

:VC10
@echo set environment for VC++ 2010 (VC10.0)
if exist "C:\Program Files\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" call "C:\Program Files\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x86_amd64
if exist "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" call "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x64

goto BUILD

:VC11
@echo set environment for VC++ 2012 (VC11.0)
if exist "C:\Program Files\Microsoft Visual Studio 11.0\VC\vcvarsall.bat" call "C:\Program Files\Microsoft Visual Studio 11.0\VC\vcvarsall.bat" x86_amd64
if exist "C:\Program Files (x86)\Microsoft Visual Studio 11.0\VC\vcvarsall.bat" call "C:\Program Files (x86)\Microsoft Visual Studio 11.0\VC\vcvarsall.bat" x64

goto BUILD


:SET_VC_VER
@echo [1] : VC++ 2005 (VC8.0)
@echo [2] : VC++ 2008 (VC9.0)
@echo [3] : VC++ 2010 (VC10.0)
@echo [4] : VC++ 2012 (VC11.0)
set /p VCN="-->"
if "%VCN%"=="1" goto VC8
if "%VCN%"=="2" goto VC9
if "%VCN%"=="3" goto VC10
if "%VCN%"=="4" goto VC11

:END
pause
